<?php

    function GoogleTranslateGetLangs($userLanguage = NULL) // $userLanguage - язык на котором будет возвращаемый список
    {
        global $g_config;
        $ret = array();

        $userLanguage = empty($userLanguage) ? LANG : $userLanguage;

        $langsUrl = "https://www.googleapis.com/language/translate/v2/languages?key=" . $g_config['google_translate']['key'] . "&target=" . $userLanguage;

        //$json = file_get_contents($langsUrl);

        $ch  = curl_init();
        curl_setopt($ch, CURLOPT_URL, $langsUrl);
        curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
        curl_setopt($ch, CURLOPT_AUTOREFERER, 1);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
       
        $json = curl_exec($ch);
        curl_close($ch);

        $obj = json_decode($json);
        foreach($obj->data->languages as $d)
        {
            $ret[$d->language] = $d->name;
        }
        return $ret;
    }

    function GoogleTranslateProcessText($text, $langSrc, $langDst = NULL)
    {
        global $g_config;

        if ($langDst === NULL) $langDst = LANG;
        $ret = "";
       
        $data = array();
        $data["eotf"]    = "1";
        $data["file"]    = "";
        $data["hl"]      = "en";
        $data["ie"]      = "UTF-8";
        $data["js"]      = "n";
        $data["layout"]  = "2";
        $data["prev"]    = "_t";
        $data["sl"]      = $langSrc == "detect" ? "auto" : $langSrc;
        $data["text"]    = $text;
        $data["tl"]      = $langDst;
       
       
        $post = "";
        foreach ($data as $k => $v)
        {
            $post .= $k . "=" . $v . "&";
        }
        $post .= "abcdef=1";
        
        //the following curl request is made to get the authorization token
        $ch  = curl_init();
        $url = "http://translate.google.ru/";
        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1);
        curl_setopt($ch, CURLOPT_AUTOREFERER, 1);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $post);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
       
        $response = curl_exec($ch);

        curl_close($ch);
                                                                                         
        // к нам часто приходит html с charset не utf-8 а KOI8-R поэтому конвертим ответ:
        $charsetPos = strpos($response, "charset=");
        if ($charsetPos !== false)
        {
            $charsetPos += strlen("charset=");
            $charsetEndPos = strpos($response, "\"", $charsetPos) + 1;
            if ($charsetEndPos !== false)
            {
                $charset = substr($response, $charsetPos, $charsetEndPos - $charsetPos - 1);
                if (strcasecmp($charset, "UTF-8") != 0)
                {
                    $response = iconv($charset, 'UTF-8', $response);
                }
            }
        }
       
        //@todo process data using DOM
       
        if ($langSrc == "detect") // just detect language and return it
        {
            $srcLangPos = strpos($response, "id=nc_dl");
            if ($srcLangPos !== false)
            {
                $srcLangPos = strpos($response, "value=", $srcLangPos);
       
                if ($srcLangPos !== false)
                {
                    $left  = strpos($response, "\"", $srcLangPos) + 1;
                    $right = strpos($response, "\"", $left);
                    $ret = substr($response, $left, $right - $left);
                }
            }
        }
        else // translate text
        {
            $srcLangPos = strpos($response, "id=result_box");
            if ($srcLangPos !== false)
            {
                $right = strpos($response, "</span>", $srcLangPos);
       
                $srcLangPos = strpos($response, "\">", $srcLangPos) + 2;
                $innerPos   = strpos($response, "<span", $srcLangPos);
       
                if ($innerPos !== false && $innerPos < $right)
                {
                    $left = strpos($response, "\">", $srcLangPos) + 2;
                }
                else
                {
                    $left = $srcLangPos;
                }
       
       
                if ($left != 2 && $right !== false)
                {
                    $ret = substr($response, $left, $right - $left);
                }
            }
        }

        if ($ret == "")
        {
            if ($langSrc == "detect")
            {
                $ret = "en";
            }
            else
            {
                $ret = $text;
            }
        }
        return $ret;
    }


    function GoogleTranslateDetectLang($text)
    {
        return GoogleTranslateProcessText($text, "detect");
    }
    
?>